/* sxplorer:
 * Copyright 1996 Y.YONEYAMA(fj9y-ynym@asahi-net.or.jp)
 */
#include "sxplorer.h"

/* sxplorer.c */
extern Widget root;
extern int display_width, display_height;
extern char DesktopFile[], TrashFolder[];

/* icon.c */
extern Icon *_icons[];
extern int _nicon;

/* data.c */
extern struct _IconData IconData[];

char *write_str(dst, str)
char *dst;
char *str;
{
  char *p = dst;
  int i;
  for(i=0;i<strlen(str);i++)
  {
    if(str[i] < ' ' || str[i] == '\\')
    {
      *dst++ = '\\';
      if(str[i] == '\\')
        *dst++ = str[i] + '\\';
      else
        *dst++ = str[i] + '@';
    }
    else
    {
      *dst++ = str[i];
    }
  }
  *dst++ = '\0';
  return(p);
}

char *read_str(dst, str)
char *dst;
char *str;
{
  char *p = dst;
  int i;
  for(i=0;i<strlen(str);i++)
  {
    if(str[i] == '\\')
    {
      i++;
      if(str[i] == '\\')
        *dst++ = '\\';
      else
        *dst++ = str[i] - '@';
    }
    else
    {
      *dst++ = str[i];
    }
  }
  *dst++ = '\0';
  return(p);
}

void delete_eol(str)
char *str;
{
  int i;
  for(i=strlen(str)-1;i>0;i--)
    if(str[i] < ' ') str[i] = '\0';
    else break;
}

char *next_arg(str)
char *str;
{
  int i;
  for(i=0;i<strlen(str);i++)
    if(str[i] == ' ') return(&str[i+1]);
  return(&str[i]);
}

int ReadAliases()
{
  FILE *fp;
  int i;
  fp = fopen(DesktopFile, "rb");
  if(fp == NULL)
    return(0);
  while(1)
  {
    char line[1024 + 256 + 2];
    char name[256*2], path[1024*2], option[256], picture[256];
    char name2[256], path2[1024];
    int x, y, type;
    if(fgets(line, 512, fp) == NULL) break;
    sscanf(line, "%s%d%d", name, &x, &y);
    if(fgets(line, 512, fp) == NULL) break;
    delete_eol(line);
    sscanf(line, "%s", path);
    strncpy(option, next_arg(line), 256);
    if(fgets(line, 512, fp) == NULL) break;
    sscanf(line, "%s%d", picture, &type);
    if(x < 0) x = display_width + x;
    if(y < 0) y = display_height + y;
    if(x > display_width - 32) x = display_width - 32;
    if(y > display_height - 32) y = display_height - 32;
    if(strcmp(picture, ICON_BROKEN) == 0)
      CreateIcon(root, x, y, read_str(name2, name), read_str(path2, path),
          option, GetFileType(path), type);
    else
      CreateIcon(root, x, y, read_str(name2, name), read_str(path2, path),
          option, GetIconData(picture), type);
    i++;
  }
  fclose(fp);
  return(i);
}

void WriteAliases()
{
  FILE *fp;
  int i;
  if(_nicon < 2) return;
  fp = fopen(DesktopFile, "wb");
  if(fp == NULL)
    return;
  for(i = 0; i< _nicon; i++)
  {
    char name[256*2], path[1024*2];
    if(_icons[i]->deleted == False && _icons[i]->parent == root)
    {
      int x, y;
      x = _icons[i]->x;
      y = _icons[i]->y;
      if(x < 0) x = 0;
      if(y < 0) y = 0;
      fprintf(fp,"%s %d %d\n", write_str(name, _icons[i]->name), x, y);
      fprintf(fp,"\t%s %s\n", write_str(path, _icons[i]->path),
          _icons[i]->option);
      fprintf(fp, "\t%s %d\n", IconData[_icons[i]->picture].name,
          _icons[i]->type);
    }
  }
  fclose(fp);
dprintf("WriteAliases(%s)\n", DesktopFile);
}

