/* sxplorer:
 * Copyright 1996 Y.YONEYAMA(fj9y-ynym@asahi-net.or.jp)
 */
#include "sxplorer.h"

#include "icons/broken.xpm"
#include "icons/system.xpm"
#include "icons/trash.xpm"
#include "icons/trashful.xpm"
#include "icons/destroy.xpm"
#include "icons/exit.xpm"
#include "icons/folder.xpm"
#include "icons/text.xpm"
#include "icons/manytext.xpm"
#include "icons/exec.xpm"
#include "icons/link.xpm"
#include "icons/flink.xpm"

#include "icons/csource.xpm"
#include "icons/cheader.xpm"
#include "icons/make.xpm"
#include "icons/tex.xpm"
#include "icons/picture.xpm"

/* sxplorer.c */
extern Widget root;
extern GC gc;

struct {
  char *name;
  char **xpmdata;
} icondata[] = {
  {ICON_TEXT,     text_xpm},
  {ICON_MANYTEXT, manytext_xpm},
  {ICON_BROKEN,   broken_xpm},
  {ICON_SYSTEM,   system_xpm},
  {ICON_EXIT,     exit_xpm},
  {ICON_FOLDER,   folder_xpm},
  {ICON_TRASH,    trash_xpm},
  {ICON_DESTROY,  destroy_xpm},
  {ICON_TRASHFULL,trashful_xpm},
  {ICON_EXEC,     exec_xpm},
  {ICON_LINK,     link_xpm},
  {ICON_FLINK,    flink_xpm},

  {ICON_CSOURCE,  csource_xpm},
  {ICON_CHEADER,  cheader_xpm},
  {ICON_MAKE,     make_xpm},
  {ICON_TEX,      tex_xpm},
  {ICON_PICTURE,  picture_xpm},
};

struct _IconData IconData[MAX_ICONDATA];
int _nicondata = 0;

void init_icondata()
{
  int i;
  for (i = 0; i < XtNumber(icondata); i++)
  {
    int col, num;
    GetXpmSize(&(IconData[i].width), &(IconData[i].height), &col, &num,
        icondata[i].xpmdata[0]);
    IconData[i].name = icondata[i].name;
    IconData[i].picture = CreatePixmapFromData(XtDisplay(root), gc,
        icondata[i].xpmdata);
    IconData[i].open_picture = CreateDarkPixmapFromData(XtDisplay(root), gc,
        icondata[i].xpmdata);
    IconData[i].mask = CreateMaskFromPixmapData(XtDisplay(root), gc,
        icondata[i].xpmdata);
    IconData[i].drag_cursor = CreateBitmapFromPixmapData(XtDisplay(root), gc,
        icondata[i].xpmdata);
    if(IconData[i].height > 38) IconData[i].height = 38;
  }
  _nicondata = XtNumber(icondata);
}

int GetIconData(name)
char *name;
{
  int i;
  for (i=_nicondata - 1;i >= 0;i--)
  {
    if(strcmp(name, IconData[i].name) == 0)
      return(i);
  }
  fprintf(stderr,"%s: Unknown icon '%s'\n", PROGRAM_NAME, name);
  return(0); /* unknown icon */
}

void AddIconData(name, file)
char *name;
char *file;
{
  int i, j;
  int col, num;
  char **xpmdata, **CreatePixmapDataFromFile();
  if(_nicondata >= MAX_ICONDATA)
    return;
  i = _nicondata;
  IconData[i].name = XtNewString(name);
  xpmdata = CreatePixmapDataFromFile(XtDisplay(root), gc, file);
  GetXpmSize(&IconData[i].width, &IconData[i].height, &col, &num, xpmdata[0]);
  IconData[i].picture = CreatePixmapFromData(XtDisplay(root), gc, xpmdata);
  IconData[i].open_picture = CreateDarkPixmapFromData(XtDisplay(root), gc,
      xpmdata);
  IconData[i].mask = CreateMaskFromPixmapData(XtDisplay(root), gc, xpmdata);
  IconData[i].drag_cursor = CreateBitmapFromPixmapData(XtDisplay(root), gc,
      xpmdata);
  for(j=0;j<IconData[i].height + col; j++)
    XtFree(xpmdata[j]);
  XtFree((char *)xpmdata);
  _nicondata ++;
  if(IconData[i].height > 38) IconData[i].height = 38;
}

