/* sxplorer:
 * Copyright 1996 Y.YONEYAMA(fj9y-ynym@asahi-net.or.jp)
 */
#include "sxplorer.h"

/* icon.c */
extern Icon *_icons[];
extern int _nicon;

#define MAX_APPS 100
struct {
  char *paattern;
  char *command;
} ExecApplications[MAX_APPS];
int _napps = 0;

void AddApplication(pattern, command)
char *pattern;
char *command;
{
  if(_napps >= MAX_APPS) return;
  ExecApplications[_napps].paattern = XtNewString(pattern);
  ExecApplications[_napps].command = XtNewString(command);
  _napps++;
}

char *GetApplication(path)
char *path;
{
  int i;
  for(i=0;i<_napps;i++)
  {
    if(CompareFileName(ExecApplications[i].paattern, path) == 0)
      return(ExecApplications[i].command);
  }
  return(NULL);
}

char *GetArg(dst, src)
char *dst;
char *src;
{
  int i, j;
  while(*src == ' ' || *src == '\t') src++;
  for(i=0,j=0;*src != '\0';src++)
  {
    if(*src == ' ' || *src == '\t') break;
    dst[j++] = *src;
  }
  dst[j] = '\0';
  while(*src == ' ' || *src == '\t') src++;
  return(src);
}

void ExecIcon(icon)
Icon *icon;
{
  mode_t mode, GetMode();
  void ExecFile();

  mode = GetMode(icon->path);
  if(!IsExecutable(mode))
  {
    ExecFile(icon);
    return;
  }
  if (fork() == 0)
  {
    char *argv[100];
    int argc = 0;
    int i;

    argv[argc] = XtNewString(icon->path);
    argc++;
    if(strlen(icon->option) > 0)
    {
      char arg[256], *p;
      p = icon->option;
      while(1)
      {
        p = GetArg(arg, p);
        if(strlen(arg) == 0)
          break;
        argv[argc] = XtNewString(arg);
        argc++;
      }
    }
    for(i=0;i<_nicon;i++)
    {
      if(!_icons[i]->deleted && _icons[i]->selected && _icons[i] != icon)
      {
        argv[argc] = XtNewString(_icons[i]->path);
        argc++;
      }
    }
    argv[argc] = NULL;

    execvp(icon->path, argv);
    exit(1);
  }
}


void ExecFile(icon)
Icon *icon;
{
  char *cmd;
  cmd = GetApplication(icon->path);
  if(cmd == NULL) return;
dprintf("ExecFile(%s)\n", cmd);
  if (fork() == 0)
  {
    char arg[256], *p;
    char *argv[100];
    int argc = 0;
    char cwd[1024];
    int i;
    strcpy(cwd, icon->path);
    for(i=strlen(cwd)-1;i>0;i--)
    {
      if(cwd[i] == '/')
      {
        cwd[i] = '\0';
        break;
      }
    }
    chdir(cwd);
    p = cmd;
    while(1)
    {
      p = GetArg(arg, p);
      if(strlen(arg) == 0)
        break;
      if(strcmp(arg, "%s") == 0)
      {
        argv[argc] = XtNewString(icon->path);
        argc++;
      }
      else
      {
        argv[argc] = XtNewString(arg);
        argc++;
      }
    }
    argv[argc] = NULL;
    execvp(argv[0], argv);
    exit(1);
  }
}

