/* sxplorer:
 * Copyright 1996 Y.YONEYAMA(fj9y-ynym@asahi-net.or.jp)
 */
#include "sxplorer.h"

/* sxplorer.c */
extern Widget root;
extern int display_width, display_height;
extern char HomeFolder[];

/* icon.c */
extern Icon *_icons[];
extern int _nicon;

void CreateSystemFolder(parent)
Widget parent;
{
  p_mode GetPMode();
  CreateIcon(parent, 0, 0, "Root", "/", "", GetIconData(ICON_FOLDER),
      P_SYSTEM | GetPMode("/"));
  CreateIcon(parent, 0, 0, "Home", HomeFolder, "", GetIconData(ICON_FOLDER),
      P_SYSTEM | GetPMode(HomeFolder));
  CreateIcon(parent, 0, 0, "Path", NAME_PATH, "", GetIconData(ICON_FOLDER),
      P_SYSTEM);
  CreateIcon(parent, 0, 0, "Exit", NAME_EXIT, "", GetIconData(ICON_EXIT),
      P_SYSTEM);
}

void CreatePathFolder(parent)
Widget parent;
{
  int k, kk;
  char *p, *GetSepString();
  char path[1024];
  char label[256];

  p = getenv("PATH");
  while(1)
  {
    p = GetSepString(path, p, ':');
    if(strlen(path) == 0) break;
    if(path[0]== '.' || strlen(path) < 1) continue;
    if(path[strlen(path)-1] == '/') path[strlen(path)-1] = '\0';
    if(GetMode(path) == NOTEXISTS) continue;
    for(kk=0,k=0;k<strlen(path);k++, kk++)
    {
      if(path[k] == '/' && k > 0)
        label[kk++] = '\n';
      label[kk] = path[k];
    }
    label[kk] = '\0';
    CreateIcon(parent, 0, 0, label, path, "", GetIconData(ICON_FOLDER),
        P_SYSTEM | GetPMode(path));
  }
}

void SystemExit()
{
  ExitDialog();
}

void DestroyTrash()
{
  DestroyDialog();
}

void OpenSystem(icon)
Icon *icon;
{
  if(strcmp(icon->name, NAME_SYSTEM) == 0 ||
     strcmp(icon->name, NAME_PATH) == 0)
  {
    OpenFolder(icon);
  }
  else if(strcmp(icon->name, NAME_EXIT) == 0)
  {
    SystemExit();
  }
  else if(strcmp(icon->name, NAME_DESTROY) == 0)
  {
    DestroyTrash();
  }
}

void DestroySystem(icon)
Icon *icon;
{
dprintf("DestroySystemIcon(%s)\n", icon->name);
  if(strcmp(icon->name, NAME_SYSTEM) == 0)
  {
    SystemExit();
  }
  else if(icon->parent == root && ISPALIAS(icon->type))
  { /* remove system alias */
    DestroyIcon(icon->widget, NULL, NULL, 0);
  }
  else
    XBell(XtDisplay(icon->widget), 0);
}

void ExecSystem(icon)
Icon *icon;
{
  int i;
  if(strcmp(icon->name, NAME_DESTROY) == 0)
  {
    for(i=0;i<_nicon;i++)
    {
      if(!_icons[i]->deleted && _icons[i]->selected &&
        !ISPSYSTEM(_icons[i]->type))
      { /* remove file */
        RemoveDialog(_icons[i]->path);
      }
    }
  }
}

