/* sxplorer:
 * Copyright 1996 Y.YONEYAMA(fj9y-ynym@asahi-net.or.jp)
 */
#include "sxplorer.h"

/* sxplorer.c */
extern Widget root;
extern Display *display;
extern GC gc;
extern char HomeFolder[];
extern struct global_options GlobalOptions;

char IconPath[1024];

char *GetArg();

char *GetSepString(dst, src, sep)
char *dst;
char *src;
char sep;
{
  int i;
  if(*src == sep) src++;
  for(i=0;*src!='\0';)
  {
    if(*src == sep) break;
    *dst++ = *src++;
  }
  *dst = '\0';
  return(src);
}

void LoadIniFile()
{
  FILE *fp;
  char fname[1024];
  char buf[1024];
  strcpy(IconPath, "");
  sprintf(fname, "%s/%s", HomeFolder, USERINI_FILE);
  fp = fopen(fname, "r");
  if(fp == NULL) return;
  while(fgets(buf, 1024, fp) != NULL)
  {
    char str[1024], str2[1024], *p;
    delete_eol(buf);
    p = GetArg(str, buf);
    if(strlen(str) == 0 || str[0] == '#') continue;
    if(strcmp(str, "IconPath") == 0)
    {
      p = GetArg(str, p);
      strcpy(IconPath, str);
    }
    else if(strcmp(str, "Desktop") == 0)
    {
      Pixmap pm;
      p = GetArg(str, p);
      pm = CreatePixmapFromFile(display, gc, str);
      XSetWindowBackgroundPixmap(display, RootWindow(display, 0), pm);
      XClearWindow(display, RootWindow(display, 0));
    }
    if(strcmp(str, "IconData") == 0)
    {
      p = GetArg(str, p);
      p = GetArg(str2, p);
      if(str2[0] == '/' && access(str2, R_OK) == 0)
        AddIconData(str, str2);
      else /* search IconPath */
      {
        p = IconPath;
        while(1)
        {
          char  s[1024];
          p = GetSepString(s, p, ':');
          if(strlen(s) == 0) 
          {
            fprintf(stderr, "%s: IconData not found! '%s'\n", PROGRAM_NAME,
                str2);
            break;
          }
          strcat(s, "/");
          strcat(s, str2);
          if(access(s, R_OK) == 0)
          {
            AddIconData(str, s);
            break;
          }
        }
      }
    }
    else if(strcmp(str, "SetIcon") == 0)
    {
      p = GetArg(str, p);
      p = GetArg(str2, p);
      AddFileType(str, str2);
    }
    else if(strcmp(str, "SetApp") == 0)
    {
      p = GetArg(str, p);
      AddApplication(str, p);
    }
    else if(strcmp(str, "HideWMIcons") == 0)
    {
      GlobalOptions.HideWMIcons = True;
    }
    else if(strcmp(str, "HideDotFiles") == 0)
    {
      GlobalOptions.HideDotFiles = True;
    }

  }

  fclose(fp);
}

